#usage LinuxTest.sh filter
#Since IFS is changed later, replace spaces in $1 to newlines 
filter=$(echo "`echo $1 | tr ' ' '\n'`")
#Set the IFS to newline char
OIFS=$IFS
IFS="
"
#for each user in /etc/passwd
for userline in `cat /etc/passwd | $filter`
do
#get username
   username=$(echo "`echo $userline | awk -F\":\" '{print $1}'`")
#get home dir perms
   homedir=$(echo "`echo $userline | cut -d: -f6`")
   homedirperms=$(echo "`ls -ld $homedir | cut -d\" \" -f1`")
#get groups
   groupsLine=$(echo "`groups $username | cut -d\":\" -f2 | sed -e 's/^ //' | sed -e 's/ /,/g'`")
#get Umask.
   shel=$(echo "$userline" | cut -d: -f7)
     noProfile=true
     shcsh=$(echo "$shel" | grep -e csh$)
     	if [ "$shcsh" = "" ] 
     	then
     		shbsh=$(echo "$shel" | grep -e bash$)
     		if [ "$shbsh" = "" ]
     		then
     			if [ -f $homedir/.profile ]
     		then
     			profilePath=$homedir/.profile
     			noProfile=false
     		fi
     		else
     			if [ -f $homedir/.bash_profile ]
     	  	then
     	   		profilePath=$homedir/.bash_profile
     	   	elif [ -f $homedir/.bash_login ]
     	   	then
     	   		profilePath=$homedir/.bash_login
     	   	else 
     			profilePath=$homedir/.profile
     	   	fi
     			noProfile=false
     		fi
     	else
     		if [ -f $homedir/.cshrc ]
     		 then
     			profilePath=$homedir/.cshrc
     		 else
     		 	profilePath=$homedir/.login
     		fi
     		noProfile=false
     	fi
     if [ "${noProfile}" = "false" ]
     then
     	umaskVal=$(echo "`cat $profilePath 2> /dev/null | grep -e ^umask | cut -d\" \" -f2`")
     fi
     if [ "$umaskVal" = "" ]
     then
     	umaskVal="22"
     fi

#get shadow related attributes
   shadowLine=$(echo "`cat /etc/shadow | grep -e \"^$username:\"`")
   passwordC=$(echo "$shadowLine" | cut -d: -f2)
   uline=$(echo "$userline" | cut -d: -f1,3,5,6,7)
   sline=$(echo "$shadowLine" | cut -d: -f3,4,5,6,7,8)
#get passwd to determine account status
   BANG="!"
   accountSuspended="0"
   if  [ "${passwordC:0:1}" = "$BANG" ]
   then
       accountSuspended="1"
   fi
   oneline=$(echo "$uline:$sline:$umaskVal:$accountSuspended:$homedirperms:$groupsLine:PosixConnectorRoot")
   echo $oneline
done
#reset the Internal Field Separator
IFS=$OIFS
